#!/bin/bash

# Пинг диапазона IP адресов

_tw="1"
((pw = 0))

#время перед выходом в режиме потоков
((_lloop=10))

par=$1
if [ "$par" == "" ] ; then
	echo -n "IP (или \"help\" для подсказки) ?:"
	read ipurl
else
	ipurl=$par
fi

if [ "$ipurl" == "help" ]; then
	echo ""
	echo ">>> $0 - принятая форма применения: <<<"
	echo "<ip>                 - указание IP адрреса например:"
	echo "                       192.168.1.1         это один адрес;"
	echo "                       192.168.1.1-254     это диапазон адресов с 192.168.1.1 по 192.168.1.254;"
	echo "                       192.168.0-10.1-254  это тоже диапазон адресов с 192.168.0.1 по 192.168.10.254"
	echo "$0 <ip> c    - перебор адресов с пингом в цикле с выводом на экран"
	echo "$0 <ip> cp   - формирование отдельных потоков пинга по диапазону адресов с выводом на экран"
	echo "                      (внимание! производится ожидание завершения 60 сек всех потоков перед окончанием работы)"
	echo "$0 <ip> fire - массивный Ping одного адреса"
	exit 0
fi

mode=$2
if [ "$mode" == "" ] ; then
	echo "Укажите режим работы:"
	echo "c      - обычный Ping (по списку адресов) с выводом в консоль"
	echo "cp     - обычный Ping (по списку адресов в режиме потока) с выводом в консоль"
	echo "fire   - массивный Ping одного адреса"
	echo -n "режим ?:"
	read mode
fi

par=$(echo -e $ipurl | sed "s/\./ /g")
#echo "$par"
ip1=$(echo -e $par | awk '{print($1)}')
ip2=$(echo -e $par | awk '{print($2)}')
ip3=$(echo -e $par | awk '{print($3)}')
ip4=$(echo -e $par | awk '{print($4)}')
#echo "ip1=$ip1  ip2=$ip2  ip3=$ip3  ip4=$ip4"

#
ip1=$(echo -e $ip1 | sed "s/-/ /g")
ip1_1=$(echo -e $ip1 | awk '{print($1)}')
ip1_2=$(echo -e $ip1 | awk '{print($2)}')
if [ "$ip1_2" == "" ] ; then
	ip1_2=$ip1_1
fi
#echo "ip1_1=$ip1_1  ip1_2=$ip1_2"

#
ip2=$(echo -e $ip2 | sed "s/-/ /g")
ip2_1=$(echo -e $ip2 | awk '{print($1)}')
ip2_2=$(echo -e $ip2 | awk '{print($2)}')
if [ "$ip2_2" == "" ] ; then
	ip2_2=$ip2_1
fi
#echo "ip2_1=$ip2_1  ip2_2=$ip2_2"

#
ip3=$(echo -e $ip3 | sed "s/-/ /g")
ip3_1=$(echo -e $ip3 | awk '{print($1)}')
ip3_2=$(echo -e $ip3 | awk '{print($2)}')
if [ "$ip3_2" == "" ] ; then
	ip3_2=$ip3_1
fi
#echo "ip3_1=$ip3_1  ip3_2=$ip3_2"

#
ip4=$(echo -e $ip4 | sed "s/-/ /g")
ip4_1=$(echo -e $ip4 | awk '{print($1)}')
ip4_2=$(echo -e $ip4 | awk '{print($2)}')
if [ "$ip4_2" == "" ] ; then
	ip4_2=$ip4_1
fi
#echo "ip4_1=$ip4_1  ip4_2=$ip4_2"


#
function cpingone()
{
	ad="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
	str=$(ping -c 1 $ad 2>&1>/dev/null)
	ret=$?
	if [ ${ret} -eq 0 ] ; then
		echo "$ad"
	fi
}

function cloop()
{
	ip21=$ip2_1
	ip31=$ip3_1
	ip41=$ip4_1
	while( ((ip1_1 <= ip1_2)) ) ; do
	 ip2_1=$ip21
	 while( ((ip2_1 <= ip2_2)) ) ; do
	  ip3_1=$ip31
	  while( ((ip3_1 <= ip3_2)) ) ; do
	   ip4_1=$ip41
	   while( ((ip4_1 <= ip4_2)) ) ; do
	    cpingone
	    ((ip4_1 = ip4_1 + 1))
	   done
	   ((ip3_1 = ip3_1 + 1))
	  done
	  ((ip2_1 = ip2_1 + 1))
	 done
	 ((ip1_1 = ip1_1 + 1))
	done
}

function cploop()
{
	ip21=$ip2_1
	ip31=$ip3_1
	ip41=$ip4_1
	while( ((ip1_1 <= ip1_2)) ) ; do
	 ip2_1=$ip21
	 while( ((ip2_1 <= ip2_2)) ) ; do
	  ip3_1=$ip31
	  while( ((ip3_1 <= ip3_2)) ) ; do
	   ip4_1=$ip41
	   while( ((ip4_1 <= ip4_2)) ) ; do
	    cpingone &
	    ((ip4_1 = ip4_1 + 1))
	   done
	   ((ip3_1 = ip3_1 + 1))
	  done
	  ((ip2_1 = ip2_1 + 1))
	 done
	 ((ip1_1 = ip1_1 + 1))
	done
	((pw = 0))
}




#
case $mode in
	"c")
		cloop
	;;
	"cp")
		((pw = 1))
		cploop
		#echo "loop1"
		while( ((pw > 0)) ) ; do
		 sleep 1
		done
		((lloop = _lloop))
		#echo "loop2"
		while( ((lloop > 0)) ) ; do
	 	 pp=`ps -A | grep -o ping`
	 	 if [ "$pp" == "" ] ; then
	  	  ((lloop = 0))
	 	 fi
		 sleep 1
		((lloop = lloop - 1))
		done
		
	;;
	"fire")
		echo -n "количество запросов ?:"
		read pcnt
		pip="$ip1_1.$ip2_1.$ip3_1.$ip4_1"
		((cnt=0))
		while( ((cnt < pcnt)) ); do
			str=$(ping -c 1 $pip 1>&2>/dev/null) &
			((cnt++))
		done
	;;
	*)
	;;
esac
exit 0




